unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, ToolWin, ImgList, ActnList, Grids, MxBinEditor, Clipbrd,
  ShellAPI, IniFiles, BELib, HintShadow, StdCtrls, Printers;

type
  TfrmMain = class(TForm)
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    ActionList1: TActionList;
    acOpen: TAction;
    acNew: TAction;
    New1: TMenuItem;
    Open2: TMenuItem;
    acClose: TAction;
    Close1: TMenuItem;
    mnuMRUEnd: TMenuItem;
    ToolButton11: TToolButton;
    Open1: TOpenDialog;
    acUndo: TAction;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    acSave: TAction;
    Save1: TSaveDialog;
    acSaveAs: TAction;
    Open3: TMenuItem;
    Save2: TMenuItem;
    ToolButton16: TToolButton;
    acCut: TAction;
    acCopy: TAction;
    acPaste: TAction;
    N2: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N3: TMenuItem;
    acDelete: TAction;
    Delete1: TMenuItem;
    acReload: TAction;
    N4: TMenuItem;
    R1: TMenuItem;
    acVersion: TAction;
    Help1: TMenuItem;
    About1: TMenuItem;
    acClearClipBoard: TAction;
    N7: TMenuItem;
    F1: TMenuItem;
    acInsertFile: TAction;
    C1: TMenuItem;
    acReadOnly: TAction;
    PopupMenu1: TPopupMenu;
    New2: TMenuItem;
    N5: TMenuItem;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    N6: TMenuItem;
    Delete2: TMenuItem;
    O1: TMenuItem;
    Show1: TMenuItem;
    acViewToolBar: TAction;
    T1: TMenuItem;
    acViewStatusBar: TAction;
    T2: TMenuItem;
    N8: TMenuItem;
    C2: TMenuItem;
    accb1byte: TAction;
    accb2byte: TAction;
    accb4byte: TAction;
    accb8byte: TAction;
    accb16byte: TAction;
    N111: TMenuItem;
    N221: TMenuItem;
    N341: TMenuItem;
    N481: TMenuItem;
    N5161: TMenuItem;
    acViewAddressHeader: TAction;
    A1: TMenuItem;
    acViewByteView: TAction;
    B1: TMenuItem;
    N9: TMenuItem;
    acAsciiByte: TAction;
    acSjisByte: TAction;
    M1: TMenuItem;
    N10: TMenuItem;
    ASCII1: TMenuItem;
    JISS1: TMenuItem;
    S1: TMenuItem;
    acOption: TAction;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    acHomepage: TAction;
    W1: TMenuItem;
    N12: TMenuItem;
    acFind: TAction;
    Find1: TMenuItem;
    Find2: TMenuItem;
    ToolButton15: TToolButton;
    ToolButton17: TToolButton;
    acUnicodeByte: TAction;
    UNICODE1: TMenuItem;
    acFindNext: TAction;
    FindNext1: TMenuItem;
    acJump: TAction;
    N13: TMenuItem;
    N342: TMenuItem;
    acFindPrev: TAction;
    P1: TMenuItem;
    N14: TMenuItem;
    acSelectAll: TAction;
    ASCII2: TMenuItem;
    mnuMRUStart: TMenuItem;
    acInputStr: TAction;
    I1: TMenuItem;
    I2: TMenuItem;
    N1: TMenuItem;
    N11: TMenuItem;
    acOffsetJump: TAction;
    O2: TMenuItem;
    acJisByte: TAction;
    acEucByte: TAction;
    JIS1: TMenuItem;
    EUC1: TMenuItem;
    acViewUnderLine: TAction;
    U1: TMenuItem;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    MxBinEditor1: TMxBinEditor;
    acCloseAll: TAction;
    L1: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    acNextInstance: TAction;
    P2: TMenuItem;
    acCopyText: TAction;
    T3: TMenuItem;
    T4: TMenuItem;
    acReplace: TAction;
    N18: TMenuItem;
    Cut3: TMenuItem;
    acPrint: TAction;
    N19: TMenuItem;
    Print1: TMenuItem;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acNewExecute(Sender: TObject);
    procedure acCloseExecute(Sender: TObject);
    procedure acOpenExecute(Sender: TObject);
    procedure StatusBar1Resize(Sender: TObject);
    procedure acUndoExecute(Sender: TObject);
    procedure MxBinEditor1ChangeUndo(Sender: TObject; UndoCount: Integer);
    procedure acSaveExecute(Sender: TObject);
    procedure acSaveAsExecute(Sender: TObject);
    procedure acCutExecute(Sender: TObject);
    procedure acCopyExecute(Sender: TObject);
    procedure acPasteExecute(Sender: TObject);
    procedure acDeleteExecute(Sender: TObject);
    procedure MxBinEditor1MoveCell(Sender: TObject);
    procedure acVersionExecute(Sender: TObject);
    procedure MxBinEditor1ChangeEditMode(Sender: TObject);
    procedure MxBinEditor1ChangeFileSize(Sender: TObject);
    procedure acClearClipBoardExecute(Sender: TObject);
    procedure acInsertFileExecute(Sender: TObject);
    procedure acReadOnlyExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure acReloadExecute(Sender: TObject);
    procedure acViewToolBarExecute(Sender: TObject);
    procedure acViewStatusBarExecute(Sender: TObject);
    procedure acChangeColumnBytes(Sender: TObject);
    procedure acViewAddressHeaderExecute(Sender: TObject);
    procedure acViewByteViewExecute(Sender: TObject);
    procedure ChangeCharCode(Sender: TObject);
    procedure acOptionExecute(Sender: TObject);
    procedure acHomepageExecute(Sender: TObject);
    procedure acFindExecute(Sender: TObject);
    procedure acFindNextExecute(Sender: TObject);
    procedure acJumpExecute(Sender: TObject);
    procedure acFindPrevExecute(Sender: TObject);
    procedure acSelectAllExecute(Sender: TObject);
    procedure acInputStrExecute(Sender: TObject);
    procedure acOffsetJumpExecute(Sender: TObject);
    procedure acViewUnderLineExecute(Sender: TObject);
    procedure MxBinEditor1ChangeSearchText(Sender: TObject);
    procedure MxBinEditor1FileOpen(Sender: TObject);
    procedure MxBinEditor1FileOpenAnyInstance(Sender: TObject);
    procedure acCloseAllExecute(Sender: TObject);
    procedure acNextInstanceExecute(Sender: TObject);
    procedure acCopyTextExecute(Sender: TObject);
    procedure acReplaceExecute(Sender: TObject);
    procedure acPrintExecute(Sender: TObject);
  private
    FAppTitle: String;

    FPrintTopMargin:    Integer;
    FPrintBottomMargin: Integer;
    FPrintLeftMargin:   Integer;
    FPrintFontName:     String;
    FPrintFontSize:     Integer;
    FPrintFontStyle:    TFontStyles;
    FPrintFontCharset:  TFontCharSet;
    FPrintFileName: Boolean;
    FPrintPageNo: Boolean;
    FPrintCancel: Boolean;
   

    FSearchText: String;
    FSearchIgnoreCase: Boolean;
    FMRUList: TStringList;
    FNoClearUndoWhenFileSave: Boolean;
    FJumpAddres: String;
    FReadOnlyWhenFileOpen: Boolean;
    procedure WMDrawClipboard(var msg: TWMDrawClipboard); Message WM_DRAWCLIPBOARD;
    procedure WMChangeCBChain(var mes: TWMChangeCBChain); Message WM_CHANGECBCHAIN;
    procedure WMSetFocus(var Msg: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Msg: TWMKillFocus); message WM_KILLFOCUS;
    procedure OnFileDrop(var Msg: TWMDropFiles); message WM_DROPFILES;
    function ShiftKeyIsDown: Boolean;
    procedure ParamCheck;
    procedure SetCaption;
    procedure FileOpen(FName: String);
    procedure MRUOpen(Sender: TObject);
    function CloseConfirm: Integer;
    procedure IniLoad;
    procedure IniSave;
    procedure MRULoad;
    procedure MRUSave;
    procedure CreateMRUMenu;
    procedure DoPrint(APos, BPos: Longint);
  public
    procedure CancelPrint;
  end;

var
  frmMain: TfrmMain;
  FBeHandleList: TList;
  hNext: THandle;
  hFirst: HWND;

const
  IniName = 'BinEdit.ini';
  PANEL_SELECT   = 1;
  PANEL_FILESIZE = 2;
  PANEL_CHARCODE = 3;
  PANEL_EDITMODE = 4;

implementation

uses Version, Option, Find, Replace, Printing;

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  hNext := SetClipboardViewer(Handle);
  DragAcceptFiles(Handle, True);

  FMRUList := TStringList.Create;
  FAppTitle := Application.Title;

  acReadOnly.ShortCut     := ShortCut(Word('R'), [ssCtrl, ssShift]);
  acOption.ShortCut       := ShortCut(VK_RETURN, [ssAlt]);
  acClose.ShortCut        := ShortCut(VK_F4, [ssAlt]);
  acNextInstance.ShortCut := ShortCut(VK_TAB, [ssCtrl]);
  acCopyText.ShortCut     := ShortCut(Word('C'), [ssCtrl, ssShift]);

  SetCaption;
  acCut.Enabled    := False;
  acCopyText.Enabled := acCopy.Enabled;
  acCopyText.Enabled   := False;
  acReload.Enabled := False;


  MxBinEditor1.CaretColor := clGray;
  MxBinEditor1ChangeEditMode(Self);
  MxBinEditor1ChangeFileSize(Self);

  IniLoad;

  ParamCheck;

end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  if MxBinEditor1.GetInstanceCount = 1 then
    IniSave;
  FMRUList.Free;
end;

procedure TfrmMain.acNewExecute(Sender: TObject);
begin
  ShellExec(AnsiQuotedStr(Application.ExeName, '"'));
end;

procedure TfrmMain.acCloseExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.acOpenExecute(Sender: TObject);
begin
  Open1.FileName := MxBinEditor1.FileName;
  if not Open1.Execute then Exit;
  LockForm(Self);
  try
    FileOpen(Open1.FileName);
  finally
    UnLockForm(Self);
  end;
end;

procedure TfrmMain.FileOpen(FName: String);
begin
  if not FileExists(FName) then Exit;
  if ShiftKeyIsDown or (MxBinEditor1.Filename = '') then
  begin
    if (CloseConfirm = IDNO) or (not MxBinEditor1.Modified) then
    begin
      LockForm(Self);
      try
        MxBinEditor1.LoadFromFile(FName);
        if FReadOnlyWhenFileOpen then
          MxBinEditor1.ReadOnlyMode := True;
        SetCaption;
        acReload.Enabled := MxBinEditor1.FileName <> '';
      finally
        UnLockForm(Self);
      end;
    end;
  end else
    ShellExec(AnsiQuotedStr(Application.ExeName, '"') + ' ' + AnsiQuotedStr(FName, '"'));
end;

procedure TfrmMain.MRUOpen(Sender: TObject);
begin
  FileOpen(FMRUList[TMenuItem(Sender).Tag]);
end;

function TfrmMain.ShiftKeyIsDown: Boolean;
begin
  Result := GetKeyState(VK_SHIFT) and (not 1) <> 0;
end;

procedure TfrmMain.ParamCheck;
var
  wParam: String;
  i, j, C: Integer;
  SL: TStringList;
begin
  if ParamCount = 0 then Exit;

  C := ParamCount;
  i := 1;
  while i <= C do
  begin
    wParam := AnsiUpperCase(ParamStr(i));
    if (wParam = '/SE') and (i < C)  then
    begin
      Inc(i);
      SL := TStringList.Create;
      try
        try
          SL.LoadFromFile(ParamStr(i));
          for j := 0 to SL.Count - 1 do
            FileOpen(SL[j]);
        except
        end;
      finally
        SL.Free;
      end;
    end else
      FileOpen(ShortToLongFileName(GetFileNameByShortCutLnk(ParamStr(1))));

    Inc(i);

  end;

  MRULoad;

end;

procedure TfrmMain.StatusBar1Resize(Sender: TObject);
begin
  with StatusBar1 do
  begin
    Panels[0].Width := ClientWidth -
                       (Panels[1].Width + Panels[2].Width +
                        Panels[3].Width + Panels[4].Width); 

    // XPrWAX^CΉ
    if HandleAllocated then
      InvalidateRect(Handle, nil, True);
  end;
end;

procedure TfrmMain.acUndoExecute(Sender: TObject);
begin
  LockForm(Self);
  try
    MxBinEditor1.Undo;
  finally
    UnLockForm(Self);
  end;
end;

procedure TfrmMain.MxBinEditor1ChangeUndo(Sender: TObject;
  UndoCount: Integer);
begin
  acUndo.Enabled := UndoCount > 0;

  SetCaption;
  MxBinEditor1MoveCell(Self);
end;

procedure TfrmMain.acSaveExecute(Sender: TObject);
begin
  if (MxBinEditor1.FileName = '') or acReadOnly.Checked then
    acSaveAs.Execute
  else
  begin
    LockForm(Self);
    try
      MxBinEditor1.SaveToFile(MxBinEditor1.FileName, FNoClearUndoWhenFileSave);
    finally
      UnLockForm(Self);
    end;
  end;
end;

procedure TfrmMain.acSaveAsExecute(Sender: TObject);
begin
  Save1.FileName := MxBinEditor1.FileName;
  if Save1.Execute then
  begin
    LockForm(Self);
    try
      MxBinEditor1.SaveToFile(Save1.FileName, FNoClearUndoWhenFileSave);
    finally
      UnLockForm(Self);
    end;
  end;
end;

procedure TfrmMain.acCutExecute(Sender: TObject);
begin
  LockForm(Self);
  try
    MxBinEditor1.Cut;
  finally
    UnLockForm(Self);
  end;
end;

procedure TfrmMain.acCopyExecute(Sender: TObject);
begin
  LockForm(Self);
  try
    MxBinEditor1.Copy;
  finally
    UnLockForm(Self);
  end;
end;

procedure TfrmMain.acPasteExecute(Sender: TObject);
var
  wStr: String;
begin
  LockForm(Self);
  try
    if Clipboard.HasFormat(CF_MXBINARY) then
      MxBinEditor1.Paste
    else if Clipboard.HasFormat(CF_TEXT) then
    begin
      wStr := Clipboard.AsText;
      MxBinEditor1.InputStr(wStr);
    end;
  finally
    UnLockForm(Self);
  end;
end;

procedure TfrmMain.acDeleteExecute(Sender: TObject);
begin
  MxBinEditor1.Delete;
end;

procedure TfrmMain.WMDrawClipboard(var msg: TWMDrawClipboard);
begin
  SendMessage(hNext, WM_DRAWCLIPBOARD, 0, 0);
  acPaste.Enabled := (not MxBinEditor1.ReadOnlyMode) and
                     (Clipboard.HasFormat(CF_MXBINARY) or
                      Clipboard.HasFormat(CF_TEXT));
  acClearClipBoard.Enabled := acPaste.Enabled;
end;

procedure TfrmMain.WMChangeCBChain(var mes: TWMChangeCBChain);
begin
  if mes.Remove = hNext then hNext:= mes.Next;
  SendMessage(hNext, WM_CHANGECBCHAIN, mes.Remove, mes.Next);
  mes.Result:= 0;
end;

procedure TfrmMain.SetCaption;
var
  CapStr: String;
begin
  CapStr := ExtractFileName(MxBinEditor1.FileName);
  if CapStr = '' then
    CapStr := '';
  if MxBinEditor1.Modified then
    CapStr := CapStr + ' *';
  CapStr := CapStr + ' - ' + FAppTitle;
  if CapStr <> Caption then
    Caption := CapStr;
  Application.Title := CapTion;
end;

procedure TfrmMain.acVersionExecute(Sender: TObject);
begin
  if frmVersion = nil then
    frmVersion := TfrmVersion.Create(Self);
  frmVersion.Show;
end;

procedure TfrmMain.MxBinEditor1MoveCell(Sender: TObject);
var
  SelSize, CurrPos: Longint;
begin
  SelSize := MxBinEditor1.SelectSize;

  acCut.Enabled    := (not MxBinEditor1.ReadOnlyMode) and (SelSize > 0);
  acCopy.Enabled   := SelSize > 0;
  acCopyText.Enabled := acCopy.Enabled;
  acDelete.Enabled := MxBinEditor1.CanDelete;

  with StatusBar1.Panels[PANEL_SELECT] do
    if SelSize = 0 then
    begin
      CurrPos := MxBinEditor1.CurrentAddress;
      Text := FormatFloat('ʒu #,##0', CurrPos) + ' (0x' + IntToHex(MxBinEditor1.CurrentAddress, 2) + ')';
    end else
      Text := FormatFloat('I #,##0', SelSize) +
              ' (0x' + IntToHex(SelSize, 2) + ') oCg';

end;

procedure TfrmMain.MxBinEditor1ChangeEditMode(Sender: TObject);
begin

  with StatusBar1.Panels[PANEL_EDITMODE] do
    if MxBinEditor1.ReadOnlyMode then
      Text := ''
    else if MxBinEditor1.InsertMode then
      Text := '}'
    else
      Text := '㏑';

  acInputStr.Enabled   := not MxBinEditor1.ReadOnlyMode;
  acInsertFile.Enabled := not MxBinEditor1.ReadOnlyMode;
  acSave.Enabled       := not MxBinEditor1.ReadOnlyMode;
  acReplace.Enabled    := not MxBinEditor1.ReadOnlyMode;
  acReadOnly.Checked   :=     MxBinEditor1.ReadOnlyMode;
  acPaste.Enabled      := not MxBinEditor1.ReadOnlyMode  and
                          (Clipboard.HasFormat(CF_MXBINARY) or
                           Clipboard.HasFormat(CF_TEXT));

  MxBinEditor1MoveCell(Self);
end;

procedure TfrmMain.MxBinEditor1ChangeFileSize(Sender: TObject);
begin
  with StatusBar1.Panels[PANEL_FILESIZE] do
    Text := FormatFloat('t@C #,##0 oCg', MxBinEditor1.FileSize);
end;

procedure TfrmMain.acClearClipBoardExecute(Sender: TObject);
begin
  ClipBoard.Clear;
end;

procedure TfrmMain.OnFileDrop(var Msg: TWMDropFiles);
var
  i, FileCount: Integer;
  pName: array[0..255]of Char;
  wName: String;
begin
  try
    FileCount := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
    for i := 0 to FileCount - 1 do
    begin
      DragQueryFile(Msg.Drop, i, pName, 255);
      wName := ShortToLongFileName(GetFileNameByShortCutLnk(pName));

      if (wName <> '') and FileExists(wName) then
        FileOpen(wName);
    end;
  finally
    DragFinish(Msg.Drop);
  end;
end;

procedure TfrmMain.acInsertFileExecute(Sender: TObject);
begin
  if not Open1.Execute then Exit;
  MxBinEditor1.InsertFile(Open1.FileName);
end;

procedure TfrmMain.acReadOnlyExecute(Sender: TObject);
begin
  acReadOnly.Checked := not acReadOnly.Checked;
  MxBinEditor1.ReadOnlyMode := acReadOnly.Checked;
  acPaste.Enabled := (not MxBinEditor1.ReadOnlyMode) and
                     (Clipboard.HasFormat(CF_MXBINARY) or
                      Clipboard.HasFormat(CF_TEXT));
end;

function TfrmMain.CloseConfirm: Integer;
var
  Msg, FileName: String;
begin
  Result := IDNO;
  if MxBinEditor1.Modified then
  begin
    FileName := ExtractFileName(MxBinEditor1.FileName);
    if FileName = '' then
      FileName := '';
    Msg := FileName + ' ւ̕ύXۑ܂H';

    Result := MsgBox(Msg, MB_ICONWARNING or MB_YESNOCANCEL);

    if Result = IDYES then
      if acReadOnly.Checked then
        acSaveAs.Execute
      else
        acSave.Execute;
  end;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := (CloseConfirm = IDNO) or not MxBinEditor1.Modified;
end;

procedure TfrmMain.acReloadExecute(Sender: TObject);
var
  Msg: String;
begin
  if MxBinEditor1.FileName = '' then Exit;
  if MxBinEditor1.Modified then
  begin
    Msg := 'ύXjēǂݒ܂H';
    if MsgBox(Msg, MB_ICONWARNING or MB_YESNO) <> IDYES then Exit; 
    LockForm(Self);
    try
      MxBinEditor1.LoadFromFile(MxBinEditor1.FileName);
    finally
      UnLockForm(Self);
    end;
  end;
end;

procedure TfrmMain.acViewToolBarExecute(Sender: TObject);
begin
  acViewToolBar.Checked := not acViewToolBar.Checked;
  CoolBar1.Visible := acViewToolBar.Checked;
end;

procedure TfrmMain.acViewStatusBarExecute(Sender: TObject);
begin
  acViewStatusBar.Checked := not acViewStatusBar.Checked;
  StatusBar1.Visible := acViewStatusBar.Checked;
end;

procedure TfrmMain.acChangeColumnBytes(Sender: TObject);
begin
  TAction(Sender).Checked := True;
  case TAction(Sender).Tag of
     2: MxBinEditor1.ColumnBytes := cb2byte;
     4: MxBinEditor1.ColumnBytes := cb4byte;
     8: MxBinEditor1.ColumnBytes := cb8byte;
    16: MxBinEditor1.ColumnBytes := cb16byte;
   else MxBinEditor1.ColumnBytes := cb1byte;
  end;
end;

procedure TfrmMain.acViewAddressHeaderExecute(Sender: TObject);
begin
  acViewAddressHeader.Checked := not acViewAddressHeader.Checked;
  MxBinEditor1.HideOffsetHeader := not acViewAddressHeader.Checked;
end;

procedure TfrmMain.acViewByteViewExecute(Sender: TObject);
begin
  acViewByteView.Checked := not acViewByteView.Checked;
  MxBinEditor1.HideByteView := not acViewByteView.Checked;
end;

procedure TfrmMain.ChangeCharCode(Sender: TObject);
begin
  TAction(Sender).Checked := True;
  case TAction(Sender).Tag of
    0: begin
          MxBinEditor1.CharCode := ccASCII;
          StatusBar1.Panels[PANEL_CHARCODE].Text := 'ASCII';
       end;
    1: begin
          MxBinEditor1.CharCode := ccSJIS;
          StatusBar1.Panels[PANEL_CHARCODE].Text := 'SJIS';
       end;
    2: begin
          MxBinEditor1.CharCode := ccUNICODE;
          StatusBar1.Panels[PANEL_CHARCODE].Text := 'UNICODE';
       end;
    3: begin
          MxBinEditor1.CharCode := ccJIS;
          StatusBar1.Panels[PANEL_CHARCODE].Text := 'JIS';
       end;
    4: begin
          MxBinEditor1.CharCode := ccEUC;
          StatusBar1.Panels[PANEL_CHARCODE].Text := 'EUC';
       end;
  end;
end;

procedure TfrmMain.acOptionExecute(Sender: TObject);
begin
  frmOption := TfrmOption.Create(Self);
  try
    with frmOption do
    begin
      chkReadOnly.Checked := FReadOnlyWhenFileOpen;
      chkFileSaveWithoutClearUndo.Checked := FNoClearUndoWhenFileSave;

      pnlPrintFont.Font.Name    := FPrintFontName;
      pnlPrintFont.Font.Size    := FPrintFontSize;
      pnlPrintFont.Font.Style   := FPrintFontStyle;
      pnlPrintFont.Font.Charset := FPrintFontCharSet;
      chkPrintFileName.Checked  := FPrintFileName;
      chkPrintPageNo.Checked    := FPrintPageNo;
      udTopMargin.Position      := FPrintTopMargin;
      udBottomMargin.Position   := FPrintBottomMargin;
      udLeftMargin.Position     := FPrintLeftMargin;

      if ShowModal = mrOk then
      begin
        FReadOnlyWhenFileOpen := chkReadOnly.Checked;
        FNoClearUndoWhenFileSave := chkFileSaveWithoutClearUndo.Checked;


        FPrintFontName     := pnlPrintFont.Font.Name;
        FPrintFontSize     := pnlPrintFont.Font.Size;
        FPrintFontStyle    := pnlPrintFont.Font.Style;
        FPrintFontCharSet  := pnlPrintFont.Font.Charset;
        FPrintFileName     := chkPrintFileName.Checked;
        FPrintPageNo       := chkPrintPageNo.Checked;
        FPrintTopMargin    := udTopMargin.Position;
        FPrintBottomMargin := udBottomMargin.Position;
        FPrintLeftMargin   := udLeftMargin.Position;


        IniSave;
      end;
    end;
  finally
    FreeAndNil(frmOption);
  end;
end;

procedure TfrmMain.acHomepageExecute(Sender: TObject);
begin
  ShellExecute(0, nil, 'http://www.woodybells.com/', nil, nil, SW_SHOWNORMAL);
end;

procedure TfrmMain.IniLoad;
var
  Ini: TIniFile;
  Sec: String;
  Rct: TRect;
  ShowCmd, wInt: Integer;
begin
  Ini := TIniFile.Create(AppPath + IniName);
  try
    if MxBinEditor1.GetInstanceCount = 1 then
    begin
      Sec := 'Placement';
      Rct := StrToRect(Ini.ReadString(Sec, 'Position', IntToStr(Left) +
             ',' + IntToStr(Top) + ',' + IntToStr(Left + Width)  + ',' +
             IntToStr(Top + Height)));
      SetBounds(Rct.Left, Rct.Top, Rct.Right - Rct.Left, Rct.Bottom - Rct.Top);
      ShowCmd := Ini.ReadInteger(Sec, 'ShowCmd', SW_SHOW);
      case ShowCmd of
        SW_SHOWMAXIMIZED: WindowState := wsMaximized;
      end;
    end;

    Sec := 'Settings';

    FNoClearUndoWhenFileSave     := Ini.ReadBool(Sec, 'FClearUndoWhenFileSave', False);
    FReadOnlyWhenFileOpen        := Ini.ReadBool(Sec, 'ReadOnlyWhenFileOpen', True);
    acViewAddressHeader.Checked  := Ini.ReadBool(Sec, 'ViewAddressHeader', True);
    acViewByteView.Checked       := Ini.ReadBool(Sec, 'ViewByteView', True);
    acViewToolBar.Checked        := Ini.ReadBool(Sec, 'ViewToolBar', True);
    acViewStatusBar.Checked      := Ini.ReadBool(Sec, 'ViewStatusBar', True);
    with MxBinEditor1 do
    begin
      Font.Name          := Ini.ReadString(Sec, 'FontName', 'FixedSys');
      Font.Size          := Ini.ReadInteger(Sec, 'FontSize', 14);
      Font.Style         := StringToFontStyles(Ini.ReadString(Sec, 'FontStyle', ''));
      Font.Charset       := Ini.ReadInteger(Sec, 'FontCharset', SHIFTJIS_CHARSET);

      Font.Color         := StrToInt(Ini.ReadString(Sec, 'FontColor', '$000000'));
      Color              := StrToInt(Ini.ReadString(Sec, 'BGColor', '$FFFFFF'));
      SelectColor        := StrToInt(Ini.ReadString(Sec, 'SelectFontColor', '$000000'));
      SelectBGColor      := StrToInt(Ini.ReadString(Sec, 'SelectBGColor', '$FFEECC'));
      CurrentLineColor   := StrToInt(Ini.ReadString(Sec, 'CurrentLineFontColor', '$000080'));
      CurrentLineBGColor := StrToInt(Ini.ReadString(Sec, 'CurrentLineBGColor', '$FFFFFF'));
      AddressColor       := StrToInt(Ini.ReadString(Sec, 'AddressFontColor', '$984E00'));
      AddressBGColor     := StrToInt(Ini.ReadString(Sec, 'AddressBGColor', '$FFFFFF'));
      UnderLineColor     := StrToInt(Ini.ReadString(Sec, 'UnderLineColor', '$FF0000'));
      DoubleBuffered     := Ini.ReadBool(Sec, 'DoubleBuffered', False);
      SaveBackup         := Ini.ReadBool(Sec, 'SaveBackup', False);
      SaveBackupCount    := Ini.ReadInteger(Sec, 'SaveBackupCount', 10);
      HideOffsetHeader   := not acViewAddressHeader.Checked;
      HideByteView       := not acViewByteView.Checked;
      ViewUnderLine      := Ini.ReadBool(Sec, 'ViewUnderLine', False);
      acViewUnderLine.Checked := ViewUnderLine;

      wInt               := Ini.ReadInteger(Sec, 'ColumnBytes', 1);
      case wInt of
         2: accb2byte.Execute;
         4: accb4byte.Execute;
         8: accb8byte.Execute;
        16: accb16byte.Execute;
       else accb1byte.Execute;
      end;
      wInt               := Ini.ReadInteger(Sec, 'CharCode', 0);
      case wInt of
        1: acSjisByte.Execute;
       else acAsciiByte.Execute;
      end;
    end;
    FJumpAddres := Ini.ReadString(Sec, 'JumpAddres', '$00000');

    Coolbar1.Visible   := acViewToolBar.Checked;
    StatusBar1.Visible := acViewStatusBar.Checked;


    if MxBinEditor1.GetInstanceCount = 1 then
    begin
      Sec := 'Find';
      FSearchText := Ini.ReadString(Sec, 'Current', '');
      FSearchIgnoreCase := Ini.ReadBool(Sec, 'IgnoreCase', False);
      MxBinEditor1.SetSearchOptions(FSearchText, FSearchIgnoreCase, True);
    end;



    Sec := 'Print';
    FPrintTopMargin    := Ini.ReadInteger(Sec, 'TopMargin', 10);
    FPrintBottomMargin := Ini.ReadInteger(Sec, 'BottomMargin', 10);
    FPrintLeftMargin   := Ini.ReadInteger(Sec, 'LeftMargin', 10);
    FPrintFontName     := Ini.ReadString(Sec, 'FontName', 'FixedSys');
    FPrintFontSize     := Ini.ReadInteger(Sec, 'FontSize', 14);
    FPrintFontStyle    := StringToFontStyles(Ini.ReadString(Sec, 'FontStyle', ''));
    FPrintFontCharset  := Ini.ReadInteger(Sec, 'FontCharset', SHIFTJIS_CHARSET);
    FPrintFileName     := Ini.ReadBool(Sec, 'PrintFileName', True);
    FPrintPageNo       := Ini.ReadBool(Sec, 'PrintPageNo', True);



    MRULoad;

  finally
    Ini.Free;
  end;
end;

procedure TfrmMain.IniSave;
var
  Ini: TIniFile;
  Sec: String;
  Placement: TWindowPlacement;
  wInt: Integer;
begin
  Ini := TIniFile.Create(AppPath + IniName);
  try
    Sec := 'Placement';
    with Placement do begin
      length := SizeOf(TWindowPlacement);
      GetWindowPlacement(Handle, @Placement);
      Ini.WriteString(Sec, 'Position', RectToStr(rcNormalPosition));
      Ini.WriteString(Sec, 'ShowCmd', IntToStr(showCmd));
    end;

    Sec := 'Settings';

    Ini.WriteBool(Sec, 'FClearUndoWhenFileSave', FNoClearUndoWhenFileSave);
    Ini.WriteBool(Sec, 'ReadOnlyWhenFileOpen', FReadOnlyWhenFileOpen);
    Ini.WriteBool(Sec, 'ViewAddressHeader', acViewAddressHeader.Checked);
    Ini.WriteBool(Sec, 'ViewByteView', acViewByteView.Checked);
    Ini.WriteBool(Sec, 'ViewToolBar', acViewToolBar.Checked);
    Ini.WriteBool(Sec, 'ViewStatusBar', acViewStatusBar.Checked);

    with MxBinEditor1 do
    begin
      Ini.WriteString(Sec, 'FontName', Font.Name);
      Ini.WriteInteger(Sec, 'FontSize', Font.Size);
      Ini.WriteString(Sec, 'FontStyle', FontStylesToString(Font.Style));
      Ini.WriteInteger(Sec, 'FontCharset', Font.Charset);
      Ini.WriteString(Sec, 'FontColor', '$' + IntToHex(Font.Color, 6));
      Ini.WriteString(Sec, 'BGColor', '$' + IntToHex(Color, 6));
      Ini.WriteString(Sec, 'SelectFontColor', '$' + IntToHex(SelectColor, 6));
      Ini.WriteString(Sec, 'SelectBGColor', '$' + IntToHex(SelectBGColor, 6));
      Ini.WriteString(Sec, 'CurrentLineFontColor', '$' + IntToHex(CurrentLineColor, 6));
      Ini.WriteString(Sec, 'CurrentLineBGColor', '$' + IntToHex(CurrentLineBGColor, 6));
      Ini.WriteString(Sec, 'AddressFontColor', '$' + IntToHex(AddressColor, 6));
      Ini.WriteString(Sec, 'AddressBGColor', '$' + IntToHex(AddressBGColor, 6));
      Ini.WriteBool(Sec, 'DoubleBuffered', DoubleBuffered);
      Ini.WriteBool(Sec, 'SaveBackup', SaveBackup);
      Ini.WriteInteger(Sec, 'SaveBackupCount', SaveBackupCount);

      Ini.WriteBool(Sec, 'ViewUnderLine', ViewUnderLine);
      Ini.WriteString(Sec, 'UnderLineColor', '$' + IntToHex(UnderLineColor, 6));

      case ColumnBytes of
         cb2byte: wInt :=  2;
         cb4byte: wInt :=  4;
         cb8byte: wInt :=  8;
        cb16byte: wInt := 16;
             else wInt :=  1;
      end;
      Ini.WriteInteger(Sec, 'ColumnBytes', wInt); 

      case CharCode of
        ccSjis: wInt := 1;
           else wInt := 0;
      end;
      Ini.WriteInteger(Sec, 'CharCode', wInt); 
    end;
    Ini.WriteString(Sec, 'JumpAddres', FJumpAddres);

    Sec := 'Find';
    Ini.WriteString(Sec, 'Current', '"' + FSearchText + '"');
    Ini.WriteBool(Sec, 'IgnoreCase', FSearchIgnoreCase);

    
    Sec := 'Print';
    Ini.WriteInteger(Sec, 'TopMargin', FPrintTopMargin);
    Ini.WriteInteger(Sec, 'BottomMargin', FPrintBottomMargin);
    Ini.WriteInteger(Sec, 'LeftMargin', FPrintLeftMargin);
    Ini.WriteString(Sec, 'FontName', FPrintFontName);
    Ini.WriteInteger(Sec, 'FontSize', FPrintFontSize);
    Ini.WriteString(Sec, 'FontStyle', FontStylesToString(FPrintFontStyle));
    Ini.WriteInteger(Sec, 'FontCharset', FPrintFontCharset);
    Ini.WriteBool(Sec, 'PrintFileName', FPrintFileName);
    Ini.WriteBool(Sec, 'PrintPageNo', FPrintPageNo);

  finally
    Ini.Free;
  end;
end;

procedure TfrmMain.MRULoad;
var
  Ini: TIniFile;
  Sec: String;
  i: Integer;
  SL: TStringList;
begin
  Ini := TIniFile.Create(AppPath + IniName);
  try
    Sec := 'MRUList';
    SL := TStringList.Create;
    try
      FMRUList.Clear;
      Ini.ReadSectionValues(Sec, SL);
      for i := 0 to SL.Count - 1 do
        FMRUList.Append(SL.Values[IntToHex(i, 1)]);
    finally
      SL.Free;
    end;
    CreateMRUMenu;
  finally
    Ini.Free;
  end;
end;

procedure TfrmMain.MRUSave;
var
  Ini: TIniFile;
  Sec: String;
  i: Integer;
begin
  Ini := TIniFile.Create(AppPath + IniName);
  try
    Sec := 'MRUList';
    for i := 0 to FMRUList.Count - 1 do
      Ini.WriteString(Sec, IntToHex(i, 1), '"' + FMRUList[i] + '"');
  finally
    Ini.Free;
  end;
end;

procedure TfrmMain.acFindExecute(Sender: TObject);
begin
  if frmReplace <> nil then
    frmReplace.Close;

  frmFind := TfrmFind.Create(Self);
  try
    frmFind.chkIgnoreCase.Checked := FSearchIgnoreCase;
    frmFind.ShowModal;
  finally
    FreeAndNil(frmFind);
  end;
end;

procedure TfrmMain.acFindNextExecute(Sender: TObject);
begin
  if not MxBinEditor1.CanFindNext then
  begin
    acFind.Execute;
    Exit;
  end;

  if MxBinEditor1.FindNext = -1 then
    MsgBox('݈ʒu ' + MxBinEditor1.SearchText + ' ͌܂łB', MB_ICONINFORMATION);

end;

procedure TfrmMain.acJumpExecute(Sender: TObject);
  procedure Err;
  begin
    MsgBox('w肵AhXłB', MB_ICONINFORMATION);
    acJump.Execute;
  end;
var
  wText: String;
  wAddr: Longint;
begin
  wText := FJumpAddres;

  if CenteredInputQuery('wAhXɃWv',
                'AhX(16iw̏ꍇ͐擪"$"t)', wText, Self) then
  begin
    try
     wAddr := StrToInt(wText);
    except
      Err;
      Exit;
    end;
    if wAddr < 0 then Err;
    if not MxBinEditor1.JumpTo(wAddr) then
      MsgBox('w肵AhX͈͊OłB', MB_ICONSTOP);
    FJumpAddres := wText;
  end;
  
end;

procedure TfrmMain.acFindPrevExecute(Sender: TObject);
begin
  if not MxBinEditor1.CanFindNext then
  begin
    acFind.Execute;
    Exit;
  end;

  if MxBinEditor1.FindPrev = -1 then
    MsgBox('݈ʒuO ' + MxBinEditor1.SearchText + ' ͌܂łB', MB_ICONINFORMATION);

end;

procedure TfrmMain.acSelectAllExecute(Sender: TObject);
begin
  MxBinEditor1.SetSelection(0, MxBinEditor1.FileSize - 1);
end;

procedure TfrmMain.CreateMRUMenu;
var
  i, MenuPos: Integer;
  MRUItem: TMenuItem;
begin
  mnuMRUStart.Visible := FMRUList.Count > 0;

  //̃j[Sč폜
  MenuPos := mnuMRUStart.MenuIndex + 1;
  while mnuMRUEnd.MenuIndex  > MenuPos do
    TMenuItem(mnuMRUStart.Parent.Items[MenuPos]).Free;

  // Ēǉ
  for i := 1 to FMRUList.Count do
  begin
    MRUItem := TMenuItem.Create(Self);
    MRUItem.Caption := '&' + IntToHex(i, 1) + '. ' + FMRUList[i - 1];
    MRUItem.Tag := i - 1;
    MRUItem.OnClick := MRUOpen;
    mnuMRUStart.Parent.Insert(MenuPos + i - 1, MRUItem);
  end;

end;

procedure TfrmMain.acInputStrExecute(Sender: TObject);
var
  wText: String;
begin
  if CenteredInputQuery('', '͂ĂB', wText, Self) then
    MxBinEditor1.InputStr(wText);
end;

procedure TfrmMain.acOffsetJumpExecute(Sender: TObject);
begin
  MxBinEditor1.OffsetJump;
end;

procedure TfrmMain.acViewUnderLineExecute(Sender: TObject);
begin
  acViewUnderLine.Checked := not acViewUnderLine.Checked;
  MxBinEditor1.ViewUnderLine := acViewUnderLine.Checked;
end;

procedure TfrmMain.MxBinEditor1ChangeSearchText(Sender: TObject);
begin
  FSearchText := MxBinEditor1.SearchText;
  FSearchIgnoreCase := MxBinEditor1.SearchIgnoreCase;
end;

procedure TfrmMain.MxBinEditor1FileOpen(Sender: TObject);
var
  FName: String;
  i: Integer;
begin
  FName := MxBinEditor1.FileName;
  for i := FMRUList.Count - 1 downto 0 do
    if FMRUList[i] = FName then
      FMRUList.Delete(i);

  FMRUList.Insert(0, FName);
  while FMRUList.Count > 10 do
    FMRUList.Delete(FMRUList.Count - 1);

//  CreateMRUMenu;
  MRUSave;

end;

procedure TfrmMain.MxBinEditor1FileOpenAnyInstance(Sender: TObject);
begin
  MRULoad;
end;

procedure TfrmMain.acCloseAllExecute(Sender: TObject);
begin
  MxBinEditor1.CloseAllInstance;
end;

procedure TfrmMain.acNextInstanceExecute(Sender: TObject);
begin
  MxBinEditor1.ShowPrevWindow;
end;

procedure TfrmMain.acCopyTextExecute(Sender: TObject);
begin
  MxBinEditor1.CopyText;
end;

procedure TfrmMain.acReplaceExecute(Sender: TObject);
begin

  if frmReplace <> nil then
  begin
    frmReplace.Show;
    Exit;
  end;

  frmReplace := TfrmReplace.Create(Self);
  frmReplace.chkIgnoreCase.Checked := FSearchIgnoreCase;
  frmReplace.Show;

end;

procedure TfrmMain.WMSetFocus(var Msg: TWMSetFocus);
begin
  inherited;
end;

{##############################################################################}

procedure TfrmMain.WMKillFocus(var Msg: TWMKillFocus);
begin
  inherited;
end;

{##############################################################################}

procedure TfrmMain.acPrintExecute(Sender: TObject);
var
  PrtDlg: TPrintDialog;
  APos, BPos: Longint;
begin
  if Printer.Printers.Count = 0 then
  begin
    MsgBox('v^CXg[Ă܂B', MB_ICONSTOP);
    Exit;
  end;

  PrtDlg := TPrintDialog.Create(Self);
  try
    if MxBinEditor1.SelectSize > 0 then
    begin
      PrtDlg.Options    := [poSelection, poPrintToFile];
      PrtDlg.PrintRange := prSelection;
    end else
      PrtDlg.Options    := [poPrintToFile];

    if PrtDlg.Execute then
    begin
      if PrtDlg.PrintRange = prSelection then
        MxBinEditor1.GetSelectRange(APos, BPos)
      else
      begin
        APos := 0;
        BPos := MxBinEditor1.FileSize - 1;
      end;

      if BPos <= 0 then
      begin
        MsgBox('f[^܂B', MB_ICONINFORMATION);
        Exit;
      end;

      LockForm(Self);
      try
        FPrintCancel := False;
        frmPrinting := TfrmPrinting.Create(Self);
        try
          frmPrinting.Show;
          DoPrint(APos, BPos);
        finally
          FreeAndNil(frmPrinting);
        end;
      finally
        UnLockForm(Self);
      end;

    end;
  finally
    PrtDlg.Free;
  end;

end;

procedure TfrmMain.DoPrint(APos, BPos: Longint);
  // DPI̎擾
  function GetDPI(Horz: Boolean): Integer;
  begin
    if Horz then
      Result := GetDeviceCaps(Printer.Handle, LOGPIXELSX)
    else
      Result := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
  end;
  //
  function MM2Pixel(mm, DPI: Integer): Integer;
  begin
    Result := mm * 10 * DPI div 254
  end;
  //
  function Pixel2MM(Pixel, DPI: Integer): Integer;
  begin
    Result := Pixel * 254 div (DPI * 10);
  end;
  //
const
  BytesPerRow = 16;
var
  PageNo, x, y, cy, LineY,
  ByteViewX1, ByteViewX2,
  CurrentRow, DPIx, DPIy,
  PageCount, CharWidth,
  CharHeight, PageLines,
  wPos, ShiftRight, ShiftLeft: Integer;
  LineText, PrintFileName: String;
begin
  with Printer do
  begin
    PrintFileName := ExtractFileName(MxBinEditor1.FileName);
    if PrintFileName = '' then
      PrintFileName := '';
    Title := PrintFileName;
    BeginDoc;
    {----------------------------------------------------------------------------}
    with Canvas do
    begin
      Font.Name    := FPrintFontName;
      Font.Size    := FPrintFontSize;
      Font.Style   := FPrintFontStyle;
      Font.Charset := FPrintFontCharset;
      Font.Pitch   := fpFixed;
      CharHeight   := TextHeight(' 0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ');
      CharWidth    := TextWidth('W');
      DPIx := GetDPI(True);
      DPIy := GetDPI(False);
      x := MM2Pixel(FPrintLeftMargin, DPIx);
      y := MM2Pixel(FPrintTopMargin, DPIy);

      PageLines := (Printer.PageHeight - y - MM2Pixel(FPrintBottomMargin, DPIy))
                   div CharHeight;

      if PageLines <= 0 then
      begin
        MsgBox('\͈݂͂܂B', MB_ICONSTOP);
        Exit;
      end;

      if FPrintFileName then
        Dec(PageLines, 2);
      if FPrintPageNo then
        Dec(PageLines, 2);

      PageCount := ((BPos div BytesPerRow) - (APos div BytesPerRow)) div PageLines;
      if ((BPos div BytesPerRow) - (APos div BytesPerRow)) mod PageLines <> 0 then
        Inc(PageCount);

      CurrentRow := APos div BytesPerRow;
      LineText := MxBinEditor1.Row2HexStr(APos, BPos, CurrentRow);

      // _~[łPs擾AoCgf[^̍W߂
      ByteViewX1 := x +
                   (Length(MxBinEditor1.Row2HexStr(APos, BPos, CurrentRow)) + 1)
                    * CharWidth;
      ByteViewX2 := ByteViewX1 + (BytesPerRow * CharWidth);

      for PageNo := 1 to PageCount do
      begin
        if frmPrinting <> nil then
          frmPrinting.lblPageNo.Caption := Format('%d y[W', [PageNo]);
        cy := y;
        // wb_
        if FPrintFileName then
        begin
          TextOut(x, cy, PrintFileName);
          Inc(cy, CharHeight * 2);
        end;
        // {̈
        for LineY := 1 to PageLines do
        begin
          if FPrintCancel then
          begin
            Printer.Abort;
            Exit;
          end;
          Application.ProcessMessages;
          wPos := CurrentRow * BytesPerRow;
          if wPos <= BPos then
          begin
            LineText := MxBinEditor1.Row2HexStr(APos, BPos, CurrentRow);
            TextOut(x, cy, LineText);

            // oCgr[f[^
            LineText := MxBinEditor1.GetByteViewText(CurrentRow * BytesPerRow - 3, BytesPerRow + 4);
            if wPos < APos then
              ShiftRight := (APos - wPos) * CharWidth
            else
              ShiftRight := 0;
            if wPos + BytesPerRow - 1 > BPos then
              ShiftLeft  := (wPos + BytesPerRow - BPos - 1) * CharWidth
            else
              ShiftLeft  := 0;

            // ClipRectZbg
            IntersectClipRect(Handle, ByteViewX1 + ShiftRight, cy, ByteViewX2 - ShiftLeft, cy + CharHeight);
            try
              TextRect(Rect(ByteViewX1, cy, ByteViewX2, cy + CharHeight),
                       ByteViewX1 - (CharWidth * 3), cy, LineText);
            finally
              // ClipRectɖ߂B
              SelectClipRgn(Handle, THandle(nil));
            end;
          end;
          Inc(cy, CharHeight);
          Inc(CurrentRow);  
        end;
        // tb^
        if FPrintPageNo then
        begin
          Inc(cy, CharHeight * 2);
          TextOut(x, cy, Format('%d y[W', [PageNo]));
        end;
        // y[W
        if PageNo < PageCount then
          Printer.NewPage;
      end;
    end;
    {----------------------------------------------------------------------------}
    EndDoc;
  end;
end;

procedure TfrmMain.CancelPrint;
begin
  FPrintCancel := True;
end;

end.
